#include <bits/stdc++.h>

using namespace std;
using ll = long long;


ll s;

vector<vector<ll>> MakeNewPref(int l, int numb, vector<vector<ll>> vec) {
    if (l == 1) {
        vector<vector<ll>> newvec(vec.size() - 1, vector<ll>(vec[0].size()));
        for (int i = 0; i < vec.size() - 2; i++) {
            for (int j = 0; j < vec[0].size() - 1; j++) {
                if (i < numb) {
                    newvec[i][j] = vec[i][j];
                } else {
                    if (numb == 0) {
                        newvec[i][j] = vec[i + 1][j] - vec[0][j];
                    } else {
                        newvec[i][j] = vec[i + 1][j] - vec[numb][j] + vec[numb - 1][j];
                    }
                }
            }
        }
        for (int j = 0; j < vec[0].size() - 1; j++) {
            newvec[vec.size() - 2][j] = vec[vec.size() - 1][j];
        }
        for (int i = 0; i < vec.size() - 1; i++) {
            if (i < numb) {
                newvec[i][vec[0].size() - 1] = vec[i][vec[0].size() - 1];
            } else {
                newvec[i][vec[0].size() - 1] = vec[i + 1][vec[0].size() - 1];
            }
        }
        return newvec;
    } else {
        vector<vector<ll>> newvec(vec.size(), vector<ll>(vec[0].size() - 1));
        for (int j = 0; j < vec[0].size() - 2; j++) {
            for (int i = 0; i < vec.size() - 1; i++) {
                if (j < numb) {
                    newvec[i][j] = vec[i][j];
                } else {
                    if (numb == 0) {
                        newvec[i][j] = vec[i][j + 1] - vec[i][0];
                    } else {
                        newvec[i][j] = vec[i][j + 1] - vec[i][numb] + vec[i][numb - 1];
                    }
                }
            }
        }
        for (int i = 0; i < vec.size(); i++) {
            newvec[i][vec[0].size() - 2] = vec[i][vec[0].size() - 1];
        }
        for (int j = 0; j < vec[0].size() - 1; j++) {
            if (j < numb) {
                newvec[vec.size() - 1][j] = vec[vec.size() - 1][j];
            } else {
                newvec[vec.size() - 1][j] = vec[vec.size() - 1][j + 1];
            }
        }
        return newvec;
    }
}

vector<pair<int, int>> pb(vector<vector<ll>> &vec, vector<pair<int, int>> v, pair<int, int> val) {
    int l = val.first;
    int a = val.second;
    if (l == 1) {
        int str = vec[a][vec[0].size() - 1];
        v.push_back({1, str + 1});
    } else {
        int str = vec[vec.size() - 1][a];
        v.push_back({2, str + 1});
    }
    return v;
}

void solve(vector<vector<ll>> vec, int w, int h, vector<pair<int, int>> d = {}) {
    if (vec.size() == 1 || vec[0].size() == 1) {
        return;
    }
    for (int i = 0; i < w - 1; i++) {
        for (int j = 0; j < h - 1; j++) {
            if (vec[i][j] == s) {
                cout << "YES" << "\n";
                cout << d.size() + (h - 2 - j) + (w - 2 - i) << "\n";
                for (auto i: d) {
                    cout << i.first << " " << i.second << "\n";
                }
                for (int k = j + 1; k < h - 1; k++) {
                    cout << 2 << " " << vec[w - 1][k] + 1 << "\n";
                }
                for (int k = i + 1; k < w - 1; k++) {
                    cout << 1 << " " << vec[k][h - 1] + 1 << "\n";
                }
                exit(0);
            }
        }
    }
    for (int j = 0; j < h/2; j++) {
        for (int i = 0; i < w/2; i++) {
            solve(MakeNewPref(1, i, vec), w - 1, h, pb(vec, d, {1, i}));
            solve(MakeNewPref(2, j, vec), w, h - 1, pb(vec, d, {2, j}));
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int w, h;
    cin >> w >> h;
    vector<vector<ll>> vec(w + 1, vector<ll>(h + 1));
    for (int i = 0; i < w; i++) {
        vec[i][h] = i;
    }
    for (int i = 0; i < h; i++) {
        vec[w][i] = i;
    }
    vector<vector<ll>> inp(w, vector<ll>(h));
    for (int i = 0; i < w; i++) {
        for (int j = 0; j < h; j++) {
            cin >> inp[i][j];
        }
    }
    vec[0][0] = inp[0][0];
    for (int i = 1; i < h; i++) {
        vec[0][i] = vec[0][i - 1] + inp[0][i];
    }
    for (int i = 1; i < w; i++) {
        vec[i][0] = vec[i - 1][0] + inp[i][0];
    }
    for (int i = 1; i < w; i++) {
        for (int j = 1; j < h; j++) {
            vec[i][j] = vec[i - 1][j] + vec[i][j - 1] - vec[i - 1][j - 1] + inp[i][j];
        }
    }
    cin >> s;
    solve(vec, w + 1, h + 1);
    cout << "NO";
}