#include <bits/stdc++.h>

using namespace std;

typedef basic_ios<char>                ios;
typedef basic_ios<wchar_t>            wios;

typedef basic_streambuf<char>     streambuf;
typedef basic_streambuf<wchar_t> wstreambuf;
typedef basic_filebuf<char>         filebuf;
typedef basic_filebuf<wchar_t>     wfilebuf;
typedef basic_stringbuf<char>     stringbuf;
typedef basic_stringbuf<wchar_t> wstringbuf;

typedef basic_istream<char>         istream;
typedef basic_istream<wchar_t>     wistream;
typedef basic_ostream<char>         ostream;
typedef basic_ostream<wchar_t>     wostream;
typedef basic_iostream<char>       iostream;
typedef basic_iostream<wchar_t>   wiostream;

typedef basic_ifstream<char>       ifstream;
typedef basic_ifstream<wchar_t>   wifstream;
typedef basic_ofstream<char>       ofstream;
typedef basic_ofstream<wchar_t>   wofstream;
typedef basic_fstream<char>         fstream;
typedef basic_fstream<wchar_t>     wfstream;

typedef basic_istringstream<char>     istringstream;
typedef basic_istringstream<wchar_t> wistringstream;
typedef basic_ostringstream<char>     ostringstream;
typedef basic_ostringstream<wchar_t> wostringstream;
typedef basic_stringstream<char>       stringstream;
typedef basic_stringstream<wchar_t>   wstringstream;


vector<int> resh(1e6, 1);

void r() {
    resh[1] = 0;
    for (int i = 2; i < 1e6; i++) {
        if (resh[i] == 1) {
            for (int j = 2 * i; j < 1e6; j += i) {
                if (j % i == 0) {
                    resh[j] = 0;
                }
            }
        }
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    r();
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
        v[i].second = i;
    }
    sort(v.begin(), v.end());
    vector<int> color(n, 1);
    unordered_set<int> sec = {v[0].first};
    color[v[0].second] = 2;
    for (int i = 1; i < n; i++) {
        if (v[i] == v[i - 1] && color[v[i - 1].second] == 2) {
            color[v[i].second] = 2;
            continue;
        } else if (v[i] == v[i - 1] && color[v[i - 1].second] == 1) {
            continue;
        }
        bool f = false;
        for (auto j: sec) {
            if (v[i].first % j == 0 && resh[v[i].first / j] == 1) {
                f = true;
                break;
            }
        }
        if (!f) {
            color[v[i].second] = 2;
            sec.insert(v[i].first);
        }
    }
    for (auto i: color) {
        cout << i << " ";
    }
    return 0;
}